/****************************************************************************
    Qt-BSch3V schematic capture
    Copyright (C) 2002-2005 H.Okada

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*****************************************************************************/

#ifndef EDITCOMPONENTBASE_H
#define EDITCOMPONENTBASE_H

#include <qvariant.h>
#include <qdialog.h>
//Added by qt3to4:
#include <QLabel>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGridLayout>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QLabel;
class QLineEdit;
class QPushButton;
class QSpinBox;
class Q3TextEdit;
class QCheckBox;

class editcomponentBase : public QDialog
{ 
    Q_OBJECT

public:
    editcomponentBase( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, Qt::WFlags fl = 0 );
    ~editcomponentBase();

    QPushButton* buttonOk;
    QPushButton* buttonCancel;
    QLabel* PinNumber;
    QLineEdit* EditName;
    QSpinBox* SpinBlock;
    QLabel* TextLabel1_2;
    QLabel* TextLabel2;
    QLineEdit* EditReference;
    QLabel* OriginalName;
    QLabel* TextLabel3;
    QLabel* TextLabel2_2;
	Q3TextEdit* EditNote;
	QLabel* TextLabel4;
   QCheckBox* CheckNameVert;
   QCheckBox* CheckReferenceVert;
   

public slots:
    virtual void blockChanged(int);

protected:
    QGridLayout* editcomponentBaseLayout;
    QHBoxLayout* Layout1;
};

#endif // EDITCOMPONENTBASE_H
