/****************************************************************************
    BSch3V schematic capture
    Copyright (C) 1997-2006 H.Okada

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*****************************************************************************/

//XBSchΥɥȤδԤ
#include "stdafx.h"
//#include <qapplication.h>
//#include <qwidget.h>
//#include <SSize.h>
//#include <SPoint.h>
//#include <qclipboard.h>
#include <stdio.h>
#include <assert.h>
#include <string>
#include <list>
using namespace std;
#include "ce3io.h"
//#include "xbschobj.h"
//#include "xbschjunc.h"
//#include "xbschlabel.h"
//#include "xbschcomment.h"
//#include "xbschtag.h"
//#include "xbschcomponent.h"

//#include "xbschline.h"
//#include "xbschentry.h"
//#include "xbschdelobj.h"
//#include "xbschsheetinfo.h"
#include "SheetSizeInfo.h"
#include "xbschdoc.h"


SPointEmum::SPointEmum()
{
	m_list.clear();
}

SPointEmum::~SPointEmum()
{
	m_list.clear();
}

bool SPointEmum::addSPoint(SPoint point)
{
	SPointListIterator ite;
	ite = m_list.begin();
	while(ite !=m_list.end()){
		if( (ite->x()==point.x()) &&  (ite->y()==point.y()) ){
			//TRACE("SPointEmum::addSPoint() returns false\n");
			return false;
		}
		ite++;
	}
	m_list.push_back(point);
	return true;
}
//
//	SPointPtrList m_list;
//};




SXBSchDoc::SXBSchDoc()
{
//	m_bDirty = false;
//	m_bTempDirty = false;
//	m_bTempNewPlace = false;
//	m_pView = NULL;
//	m_bSelectForDrag = false;
	m_sizeSheet = SSize(1500,1000);
	init();
}

SXBSchDoc::~SXBSchDoc()
{
	init();
}

bool SXBSchDoc::isEmpty()
{
	if( (m_listMain.size() > 0) || (m_listTemp.size() > 0 )) return false;
	else return true;
}


//#define SHEETSIZE_X_MIN		640
//#define SHEETSIZE_X_MAX		5000
//#define SHEETSIZE_Y_MIN		400
//#define SHEETSIZE_Y_MAX		4000

//ȥ
void SXBSchDoc::SetSheetSize(const SSize& size)
{
	if(   size.w()<SHEETSIZE_X_MIN
		||size.w()>SHEETSIZE_X_MAX
		||size.h()<SHEETSIZE_Y_MIN
		||size.h()>SHEETSIZE_Y_MAX) return;


	m_sizeSheet = size;
}

//20060603	//Ǥɲ ֹ֤
//20060603	int SXBSchDoc::add(SXBSchObj* pObj)
//20060603	{
//20060603		if(pObj == NULL) return m_nOpCount;
//20060603		m_nOpCount++;
//20060603		m_bDirty = true;	
//20060603		pObj->setPlaceNum(m_nOpCount);	
//20060603		m_listMain.push_back(pObj);
//20060603		m_bFindCommandActive = false;
//20060603		return m_nOpCount;
//20060603	}

//֤ɲÿǤɲ ֹ֤
int  SXBSchDoc::addSelect(SXBSchObj* pObj)
{
	m_listTemp.push_back(pObj);
	setupRcTempArea();
	m_bTempNewPlace = true;
	m_bFindCommandActive = false;
	//m_bDirty = true;	
	return m_nOpCount;
}

//ꤷƤ
//ꤷƤǤϡ1ĤΥ֥ȤФʤ
int SXBSchDoc::select(const SPoint& pt)
{
	resetSelect();
	SXBSchObj* pObjSelected = NULL;
	int maxSelectWeight=0;
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte !=  m_listMain.end()){
		if( (*pObjIte)->layer() == m_editLayer
		  &&(*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			int SelectWeight = (*pObjIte)->qSelectWeight(pt) & 0xFFFF;
			if(SelectWeight > maxSelectWeight){
				maxSelectWeight = SelectWeight;
				pObjSelected = (*pObjIte);
			}
		}
		pObjIte++;
	}
	if(pObjSelected != NULL){
		SXBSchObj* pNewObj = pObjSelected->duplicate();
		pObjSelected->setRefObj(pNewObj);
		pNewObj->setRefObj(pObjSelected);
		pNewObj->setSelection(SXBSchObj::SELECT_ALL);
		m_listTemp.push_back(pNewObj);
		m_bFindCommandActive = false;
	}
	setupRcTempArea();
	setupRotateRect();
	m_bSelectForDrag = false;
	return m_listTemp.size();
}

//ϰϤꤷƤ
//Ȥϡ
//  ᥤΥꥹȤ鳺Τ򸫤Ĥ
//  ʣ֥Ȥɲä
//򤷤֤
int SXBSchDoc::select(const SRect& rc)
{
	resetSelect();
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte != m_listMain.end()){
		if( (*pObjIte)->layer() == m_editLayer
		 && (*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			unsigned nSelStatus = (*pObjIte)->testSelection(rc);
			if(nSelStatus){
				SXBSchObj* pNewObj = (*pObjIte)->duplicate();
				(*pObjIte)->setRefObj(pNewObj);
				pNewObj->setRefObj(*pObjIte);
				pNewObj->setSelection(nSelStatus);
				m_listTemp.push_back(pNewObj);
			}
		}
		*pObjIte++;
	}
	setupRcTempArea();
	setupRotateRect();
	m_bSelectForDrag = false;
	int n = m_listTemp.size();
	if(n>0){
		m_bFindCommandActive = false;
	}
	return n;
}


//ǤᥤꥹȤpush_back롣
void SXBSchDoc::pushBackToMainList(SXBSchObj* pObj,bool doTidyUp)
{
	//doTidyUp = false;
	if(m_bDoTidyUp && doTidyUp){
		if(pObj->id()==SXBSchObj::ID_JUNCTION){
			if(checkRedundancyJunction((SXBSchJunc*)pObj)){
				delete pObj;
				return;
			}
		}else if(pObj->id()==SXBSchObj::ID_WIRE || pObj->id()==SXBSchObj::ID_BUS){
			tidyUpWireBus((SXBSchLine*)pObj);
			return;
		}
	}
	m_listMain.push_back(pObj);
}

//磻䡼,󥯥  ƥå1
//ä󥯥ξǸŤ磻䡼礹
void SXBSchDoc::tidyUpWireJunction_1(int opCount)
{
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte != m_listMain.end()){
		if(   (*pObjIte)->placeNum()<opCount
			||(*pObjIte)->id() != SXBSchObj::ID_DELETEOBJ
			||(*pObjIte)->refObj() == NULL){
			pObjIte++;
			continue;
		}
		if((*pObjIte)->refObj()->id() != SXBSchObj::ID_JUNCTION){
			pObjIte++;
			continue;
		}

		SXBSchObj* pObj = (*pObjIte)->refObj(); //õ줿󥯥
		int nLayer = pObj->layer();	//õ줿󥯥Υ쥤䡼
		SPoint pj = pObj->p1();		//õ줿󥯥ΰ
		XBSchObjListIterator pObjIteW = m_listMain.begin();
		SXBSchWire* pWireVl = NULL;
		SXBSchWire* pWireVr = NULL;
		SXBSchWire* pWireHl = NULL;
		SXBSchWire* pWireHr = NULL;
		while(pObjIteW != m_listMain.end()){
			if(   (*pObjIteW)->id() != SXBSchObj::ID_WIRE
				//||(*pObjIte)->placeNum()>=opCount
				||(*pObjIteW)->layer() != nLayer 
				||(*pObjIteW)->refObj()!=NULL){
				pObjIteW++;
				continue;
			}
			if((*pObjIteW)->p1()!=pj && (*pObjIteW)->p2()!=pj){
				pObjIteW++;
				continue;
			}
			bool horz = ((*pObjIteW)->y1() == (*pObjIteW)->y2());
			bool vert = ((*pObjIteW)->x1() == (*pObjIteW)->x2());
			if((!horz && !vert)||(horz && vert)){
				pObjIteW++;
				continue;
			}
			if(horz){
				if( ((*pObjIteW)->x1()+(*pObjIteW)->x2()) > pj.x()*2 ){
					pWireHr = (SXBSchWire*)(*pObjIteW);
				}else{
					pWireHl = (SXBSchWire*)(*pObjIteW);
				}
			}else{
				if( ((*pObjIteW)->y1()+(*pObjIteW)->y2()) > pj.y()*2 ){
					pWireVr = (SXBSchWire*)(*pObjIteW);
				}else{
					pWireVl = (SXBSchWire*)(*pObjIteW);
				}
			}
			pObjIteW++;
			continue;
		}
		if(pWireHr && pWireHl){
			SXBSchWire* pNewWire = (SXBSchWire*)(pWireHl->duplicate());
			pNewWire->setX1(pWireHl->x1()+pWireHl->x2()-pj.x());
			pNewWire->setX2(pWireHr->x1()+pWireHr->x2()-pj.x());
			pNewWire->setPlaceNum(opCount);
			m_listMain.push_back(pNewWire);
			SXBSchDelObj* pDelObj;
			pDelObj = new SXBSchDelObj;		//쥪֥Ȥõ뤿ξõ֥Ȥ
			pWireHl->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
			pDelObj->setRefObj(pWireHl);					//õ֥Ȥ˵쥪֥Ȥ
			pDelObj->setPlaceNum(opCount);				
			m_listMain.push_back(pDelObj);
			pDelObj = new SXBSchDelObj;						//쥪֥Ȥõ뤿ξõ֥Ȥ
			pWireHr->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
			pDelObj->setRefObj(pWireHr);					//õ֥Ȥ˵쥪֥Ȥ
			pDelObj->setPlaceNum(opCount);				
			m_listMain.push_back(pDelObj);
		}
		if(pWireVr && pWireVl){
			SXBSchWire* pNewWire = (SXBSchWire*)(pWireVl->duplicate());
			pNewWire->setY1(pWireVl->y1()+pWireVl->y2()-pj.y());
			pNewWire->setY2(pWireVr->y1()+pWireVr->y2()-pj.y());
			pNewWire->setPlaceNum(opCount);
			m_listMain.push_back(pNewWire);
			SXBSchDelObj* pDelObj;
			pDelObj = new SXBSchDelObj;		//쥪֥Ȥõ뤿ξõ֥Ȥ
			pWireVl->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
			pDelObj->setRefObj(pWireVl);					//õ֥Ȥ˵쥪֥Ȥ
			pDelObj->setPlaceNum(opCount);				
			m_listMain.push_back(pDelObj);
			pDelObj = new SXBSchDelObj;						//쥪֥Ȥõ뤿ξõ֥Ȥ
			pWireVr->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
			pDelObj->setRefObj(pWireVr);					//õ֥Ȥ˵쥪֥Ȥ
			pDelObj->setPlaceNum(opCount);				
			m_listMain.push_back(pDelObj);
		}
		pObjIte++;
		continue;
	}
}


//磻䡼,󥯥  ƥå2
//󥯥ǸŤ磻䡼ʬԤ
void SXBSchDoc::tidyUpWireJunction_2(int opCount)
{
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte != m_listMain.end()){
		if(   (*pObjIte)->placeNum()<opCount
			||(*pObjIte)->id() != SXBSchObj::ID_JUNCTION
		    //||(*pObjIte)->layer() != m_editLayer 
			||(*pObjIte)->refObj()!=NULL){
			pObjIte++;
			continue;
		}
		int nLayer = (*pObjIte)->layer();
		SPoint pj = (*pObjIte)->p1();
		XBSchObjListIterator pObjIteW = m_listMain.begin();
		while(pObjIteW != m_listMain.end()){
			if(   (*pObjIteW)->placeNum() >= opCount
				||(*pObjIteW)->id() != SXBSchObj::ID_WIRE
				//||(*pObjIteW)->layer() != m_editLayer 
				||(*pObjIteW)->layer() != nLayer 
				||(*pObjIteW)->refObj()!=NULL){
				pObjIteW++;
				continue;
			}
			SPoint p1 = (*pObjIteW)->p1();
			SPoint p2 = (*pObjIteW)->p2();
			if(p1.x()==p2.x() && p1.x()== pj.x()){
				if( (p1.y() <= pj.y() && p2.y() <= pj.y())
				 || (p1.y() >= pj.y() && p2.y() >= pj.y())){
					pObjIteW++;
					continue;
				}
			}else if(p1.y()==p2.y() && p1.y()== pj.y()){
				if( (p1.x() <= pj.x() && p2.x() <= pj.x())
				 || (p1.x() >= pj.x() && p2.x() >= pj.x())){
					pObjIteW++;
					continue;
				}
			}else{
				pObjIteW++;
				continue;
			}
			SXBSchWire* pWire1 = (SXBSchWire*)((*pObjIteW)->duplicate());
			SXBSchWire* pWire2 = (SXBSchWire*)((*pObjIteW)->duplicate());
			pWire1->setP2(pj);
			pWire1->setPlaceNum(opCount);
			pWire2->setP1(pj);
			pWire1->setPlaceNum(opCount);
			pWire2->setPlaceNum(opCount);
			SXBSchDelObj* pDelObj = new SXBSchDelObj;		//쥪֥Ȥõ뤿ξõ֥Ȥ
			(*pObjIteW)->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
			pDelObj->setRefObj(*pObjIteW);					//õ֥Ȥ˵쥪֥Ȥ
			pDelObj->setPlaceNum(opCount);				
			m_listMain.push_back(pDelObj);
			m_listMain.push_back(pWire1);
			m_listMain.push_back(pWire2);
			pObjIteW++;
			continue;
		}
		pObjIte++;
		continue;
	}
}

//磻䡼,󥯥  ƥå3
//磻䡼󥯥ʬ䤹롣
void SXBSchDoc::tidyUpWireJunction_3(int opCount)
{
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte != m_listMain.end()){
		if(   (*pObjIte)->placeNum()<opCount
			||(*pObjIte)->id() != SXBSchObj::ID_WIRE
		    //||(*pObjIte)->layer() != m_editLayer 
			||(*pObjIte)->refObj()!=NULL){
			pObjIte++;
			continue;
		}
		int nLayer = (*pObjIte)->layer();
		SPoint p1 = (*pObjIte)->p1();
		SPoint p2 = (*pObjIte)->p2();
		XBSchObjListIterator pObjIteJ = m_listMain.begin();
		while(pObjIteJ != m_listMain.end()){
			if( //  (*pObjIteW)->placeNum() >= opCount
				  (*pObjIteJ)->id() != SXBSchObj::ID_JUNCTION
				//||(*pObjIteJ)->layer() != m_editLayer 
				||(*pObjIteJ)->layer() != nLayer 
				||(*pObjIteJ)->refObj()!=NULL){
				pObjIteJ++;
				continue;
			}
			SPoint pj = (*pObjIteJ)->p1();

			if(p1.x()==p2.x() && p1.x()== pj.x()){
				if( (p1.y() <= pj.y() && p2.y() <= pj.y())
				 || (p1.y() >= pj.y() && p2.y() >= pj.y())){
					pObjIteJ++;
					continue;
				}
			}else if(p1.y()==p2.y() && p1.y()== pj.y()){
				if( (p1.x() <= pj.x() && p2.x() <= pj.x())
				 || (p1.x() >= pj.x() && p2.x() >= pj.x())){
					pObjIteJ++;
					continue;
				}
			}else{
				pObjIteJ++;
				continue;
			}
			SXBSchWire* pWire1 = (SXBSchWire*)((*pObjIte)->duplicate());
			SXBSchWire* pWire2 = (SXBSchWire*)((*pObjIte)->duplicate());
			pWire1->setP2(pj);
			pWire1->setPlaceNum(opCount);
			pWire2->setP1(pj);
			pWire1->setPlaceNum(opCount);
			pWire2->setPlaceNum(opCount);
			SXBSchDelObj* pDelObj = new SXBSchDelObj;		//쥪֥Ȥõ뤿ξõ֥Ȥ
			(*pObjIte)->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
			pDelObj->setRefObj(*pObjIte);					//õ֥Ȥ˵쥪֥Ȥ
			pDelObj->setPlaceNum(opCount);				
			m_listMain.push_back(pDelObj);
			m_listMain.push_back(pWire1);
			m_listMain.push_back(pWire2);
			break;
		}
		pObjIte++;
		continue;
	}
}






//磻䡼,Хη
void SXBSchDoc::tidyUpWireBus(SXBSchLine* pObj)
{
	unsigned int targetID = pObj->id();
	bool horz = (pObj->y1() == pObj->y2()); 
	bool vert = (pObj->x1() == pObj->x2());
	if(horz && vert){
		delete pObj;
		return;
	}

	int k,pl,pr,n;
	if(horz){
		k=pObj->y1();
		pl = pObj->x1();
		pr = pObj->x2();
	}else if(vert){
		k=pObj->x1();
		pl = pObj->y1();
		pr = pObj->y2();
	}else{
		m_listMain.push_back(pObj);
		return;
	}
	if(pl>pr){
		n=pl;pl=pr;pr=n;
	}

	int nLayer = pObj->layer();

	
	//TRACE("Start tidyUpWireBus\n");

	bool bExecJoint = true;
	while(bExecJoint){	
		bExecJoint = false;
		XBSchObjListIterator pObjIte = m_listMain.begin();
		while(pObjIte != m_listMain.end()){
			if(   (*pObjIte)->id() == targetID
				//&&(*pObjIte)->layer() == m_editLayer 
				&&(*pObjIte)->layer() == nLayer 
				&&(*pObjIte)->refObj()==NULL){
				int plM,prM;
				SXBSchLine* pObjM = (SXBSchLine*)(*pObjIte);
				if(horz){
					if(pObjM->y1()!=k || pObjM->y2()!=k){
						pObjIte++;
						continue;
					}
					plM = pObjM->x1();
					prM = pObjM->x2();
					if(plM>prM){
						n=plM;plM=prM;prM=n;
					}
					if(prM<pl || pr<plM){
						pObjIte++;
						continue;
					}
					if(plM < pl) pl=plM;
					if(prM > pr) pr=prM;
					SXBSchDelObj* pDelObj = new SXBSchDelObj;		//쥪֥Ȥõ뤿ξõ֥Ȥ
					(*pObjIte)->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
					pDelObj->setRefObj(*pObjIte);					//õ֥Ȥ˵쥪֥Ȥ
					pDelObj->setPlaceNum(m_nOpCount);				
					m_listMain.push_back(pDelObj);
					bExecJoint = true;
				}else{
					if(pObjM->x1()!=k || pObjM->x2()!=k){
						pObjIte++;
						continue;
					}
					plM = pObjM->y1();
					prM = pObjM->y2();
					if(plM>prM){
						n=plM;plM=prM;prM=n;
					}
					if(prM<pl || pr<plM){
						pObjIte++;
						continue;
					}
					if(plM < pl) pl=plM;
					if(prM > pr) pr=prM;
					SXBSchDelObj* pDelObj = new SXBSchDelObj;		//쥪֥Ȥõ뤿ξõ֥Ȥ
					(*pObjIte)->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
					pDelObj->setRefObj(*pObjIte);					//õ֥Ȥ˵쥪֥Ȥ
					pDelObj->setPlaceNum(m_nOpCount);				
					m_listMain.push_back(pDelObj);
					bExecJoint = true;
				}
			}
			pObjIte++;
		}
	}
	if(horz){
		pObj->setX1(pl);
		pObj->setX2(pr);
	}else{
		pObj->setY1(pl);
		pObj->setY2(pr);
	}
	m_listMain.push_back(pObj);
}	



//󥯥νʣåԤ
bool SXBSchDoc::checkRedundancyJunction(SXBSchJunc* pObj)
{
	XBSchObjListIterator pObjIte = m_listMain.begin();
	int nLayer = pObj->layer();
	while(pObjIte != m_listMain.end()){
		if(   (*pObjIte)->id() == SXBSchObj::ID_JUNCTION
		    //&&(*pObjIte)->layer() == m_editLayer 
			&&(*pObjIte)->layer() == nLayer 
			&&(*pObjIte)->refObj()==NULL){
			SXBSchJunc* pObjM = (SXBSchJunc*)(*pObjIte);
			if(pObjM->p1()==pObj->p1()){
				//TRACE("checkRedundancyJunction() true\n");
				return true;
			}
		}
		pObjIte++;
	}
	return false;
}



bool SXBSchDoc::resetSelect_1(bool bDel)
{
	//֥ȤΥꥹȤʤ鲿⤷ʤ
	if(m_listTemp.size() == 0){
		m_bTempDirty = false;
		m_bTempNewPlace = false;
		return false;
	}

	bool bModifyMain = false;

	XBSchObjListIterator pObjIte;

	if(m_bTempNewPlace){
		if(!bDel){		//ɲåǡեå
			m_nOpCount++;
			bModifyMain = true;
			pObjIte = m_listTemp.begin();
			while(pObjIte != m_listTemp.end()){
				//ǡᥤΥꥹȤɲ
				if((*pObjIte)->qValid()){
					(*pObjIte)->setPlaceNum(m_nOpCount);		//ֹ򹹿
					(*pObjIte)->setRefObj(NULL);				//ȥ֥Ȥ϶ˤͭǡˤʤ
					(*pObjIte)->resetSelection();				//ե饰򥯥ꥢ롣
					pushBackToMainList(*pObjIte,true);
//20060604					m_listMain.push_back(*pObjIte);
				}
				*pObjIte++;
			}
		}else{			//ɲåǡ
			pObjIte = m_listTemp.begin();
			while(pObjIte != m_listTemp.end()){
				delete (*pObjIte);
				*pObjIte++;
			}
		}
		m_listTemp.clear();
		m_bTempDirty = false;
		m_bTempNewPlace = false;
	}else{
		if(!bDel && !m_bTempDirty){	//򤷤äˤʤˤѹäʤä
			pObjIte = m_listTemp.begin();
			while(pObjIte != m_listTemp.end()){
				if((*pObjIte)->refObj()){ //֥Ȥȥ֥Ȥľ硢ȥ֥ȤϸΥǡؤ
					SXBSchObj* pOldObj = (*pObjIte)->refObj();
					pOldObj->setRefObj(NULL);
				}
				delete (*pObjIte);
				*pObjIte++;
			}
			m_listTemp.clear();
			m_bTempDirty = false;
		}else{				//򤷤ǡѹä
			m_nOpCount++;
			bModifyMain = true;
			pObjIte = m_listTemp.begin();
			while(pObjIte != m_listTemp.end()){
				if((*pObjIte)->refObj()){ //֥Ȥȥ֥Ȥľ硢ȥ֥ȤϸΥǡؤ
					SXBSchObj* pOldObj = (*pObjIte)->refObj();
					//֥Ȥɲ
					SXBSchDelObj* pDelObj = new SXBSchDelObj;
					//qDebug("Add DeleteObj");
					pDelObj->setPlaceNum(m_nOpCount);	
					pDelObj->setRefObj(pOldObj); //֥ȤrefObj()ˤоݥ֥ȤؤΥݥ󥿤򥻥åȤ
					pOldObj->setRefObj(pDelObj); //Υ֥ȤˤϺ֥ȤؤΥݥ󥿤򥻥åȤ
					m_listMain.push_back(pDelObj);
				}
				if(!bDel){
					//ǡᥤΥꥹȤɲ
					if((*pObjIte)->qValid()){
						(*pObjIte)->setPlaceNum(m_nOpCount);		//ֹ򹹿
						(*pObjIte)->setRefObj(NULL);				//ȥ֥Ȥ϶ˤͭǡˤʤ
						(*pObjIte)->resetSelection();				//ե饰򥯥ꥢ롣
						pushBackToMainList(*pObjIte,true);
//20060604						m_listMain.push_back(*pObjIte);
					}
					else{
						//ǡõ
						delete (*pObjIte);
					}
				}else{
					//ǡõ
					delete (*pObjIte);
				}
				*pObjIte++;
			}
			m_listTemp.clear();
		}
	}

	if(bModifyMain && m_bDoTidyUp){
		tidyUpWireJunction_1(m_nOpCount);
		tidyUpWireJunction_2(m_nOpCount);
		tidyUpWireJunction_3(m_nOpCount);
	}

	m_bSelectForDrag = false;
	m_bTempDirty = false;
	m_bTempNewPlace = false;


	delOldData(m_nOpCount-10);		//Undo
	if(bModifyMain){
		m_bDirty = true;
		return true;
	}else{
		return false;
	}
}

//m_rcTempArea  m_ptTempSnapPoint ֥ȤΥꥹȤꤹ롣
void SXBSchDoc::setupRcTempArea()
{
	if(m_listTemp.size() == 0)return;
	m_rcTempArea = SRect(SPoint(INT_MAX,INT_MAX),SPoint(INT_MIN,INT_MIN));

	XBSchObjListIterator pObjIte = m_listTemp.begin();
	bool bFind1st = true;
	while(pObjIte != m_listTemp.end()){
		m_rcTempArea |= (*pObjIte)->area();
		if(bFind1st){
			m_ptTempSnapPoint = (*pObjIte)->snapPoint();
			bFind1st = false;
		}
		pObjIte++;
	}
}

void SXBSchDoc::setupRotateRect()
{
	if(m_listTemp.size() == 0)return;
	m_rcRotateRect = SRect(SPoint(INT_MAX,INT_MAX),SPoint(INT_MIN,INT_MIN));

	XBSchObjListIterator pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		m_rcRotateRect |= (*pObjIte)->rotateRect();
		pObjIte++;
	}
	//qDebug("%d,%d\n",m_rcRotateRect.l(),m_rcRotateRect.r());
}



bool SXBSchDoc::writeMinimumLb3(SWriteCE3& wce3,XBSchObjList* pList,bool bOwnOnly)
{
//typedef list<SCompIndex*> SCompIndexList;
//typedef list<SCompIndex*>::iterator SCompIndexListIterator;

	return true;
}


bool SXBSchDoc::writeCe3(SWriteCE3& wce3,XBSchObjList* pList,bool bAllObj,const SPoint* pptOrigin)
{
	SRect rcSheet(0,0,m_sizeSheet.w(),m_sizeSheet.h());
	if(pList){
		XBSchObjListIterator pObjIte = pList->begin();
		while(pObjIte != pList->end()){
			if(bAllObj || !(*pObjIte)->refObj()){
				if(rcSheet.intersect((*pObjIte)->area())){
					(*pObjIte)->writeCe3(wce3,pptOrigin);
				}
			}
			pObjIte++;
		}
	}
	return true;
}


bool SXBSchDoc::readCe3(SReadCE3& rce3,
						XBSchObjList* pList,
						const SPoint* pptOrigin,
						SXBSchSheetInfo* pSheetInfo)
{

	assert(pList!=NULL);
	string str("");
	bool bFirstSheetInfo = true;
	SXBSchObj* pObj;
	while(rce3.ReadRecord(str)!=EOF){
		if(str == "") break;		//Υ쥳ɤ̵뤹
		pObj = NULL;
		if(str == "+SHEETINFO" && bFirstSheetInfo && pSheetInfo){
			bFirstSheetInfo = false;
			if(! pSheetInfo->readCe3(rce3,pptOrigin,this)) return false;
		}else if(str == "+JUNCTION"){
				pObj = new SXBSchJunc;
		}else if(str == "+LABEL"){
				pObj = new SXBSchLabel;
		}else if(str == "+COMMENT"){
				pObj = new SXBSchComment;
		}else if(str == "+TAG"){
				pObj = new SXBSchTag;
		}else if(str == "+WIRE"){
				pObj = new SXBSchWire;
		}else if(str == "+BUS"){
				pObj = new SXBSchBus;
		}else if(str == "+DASH"){
				pObj = new SXBSchDash;
		}else if(str == "+ENTRY"){
				pObj = new SXBSchEntry;
		}else if(str == "+BENTRY"){
				pObj = new SXBSchBusEntry;
		}else if(str == "+COMPONENT"){
				pObj = new SXBSchComponent;
		}else if(str == "-BSCH3_DATA_V.1.0"){
			return true;
		}else{
			if(str[0] != '+') return false;
			str[0]='-';
			if(rce3.SkipTo(str)==EOF) return false;
			//if(rce3.SkipTo(str.replace(1,1,"-")) != SCsvIStream::GETRECORD_NORMAL)return false;
		}
		if(pObj){
			if(pObj->readCe3(rce3,pptOrigin,this)){
				if(pObj->qValid()){
					pList->push_back(pObj);
				}else{
					delete pObj;
				}
			}else{
				delete pObj;
				return false;
			}
		}
	}
	return true;
}





//β
//βȤϡ
//  ǡؤΥ֥Ȥؤֺ֥ȡפᥤΥꥹȤɲä
//                      ǡᥤΥꥹȤɲä뤳
bool SXBSchDoc::resetSelect()
{
	return resetSelect_1(false);
}


//
void SXBSchDoc::init()
{
	m_bDoTidyUp = true;
	m_bFindCommandActive = false;
	m_bSelectForDrag = false;
	m_bDirty = false;
	m_bTempDirty = false;
	m_bTempNewPlace = false;
	m_nOpCount = 0;
	m_nOldestOpCount = 0;
	m_visibleLayer =0xFF;
	m_editLayer = 0;
	m_strFind ="";
	
	

	XBSchObjListIterator pObjIte;

	pObjIte = m_listMain.begin();

	while(pObjIte != m_listMain.end()){
		delete (*pObjIte);
		pObjIte++;
	}
	m_listMain.clear();

 	pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		delete (*pObjIte);
		pObjIte++;
	}
	m_listTemp.clear();

//printf("\n");
//printf("SXBSchDoc::init() m_listMain.count()=%d,m_listTemp.count()=%d\n",m_listMain.count(),m_listTemp.count());
}

//ե뤫ɤ߹
//ｪλ0֤
//  1:եɤ߹ߥ顼
//  2:BSCH3եǤϤʤ
int SXBSchDoc::readFile(FILE* fp)
{
	if(fp ==NULL) return 1;
	SReadCE3 rce3;
	rce3.Attach(fp);

	string str("");
	if(rce3.ReadRecord(str)==EOF){	//ΥեΤȤν
		fclose(fp);
		return 0;
	}
	SXBSchSheetInfo sheetInfo;
	if(str != "+BSCH3_DATA_V.1.0") return 2;
//	if(readCe3(rce3,&m_listMain,NULL,&sheetInfo)){
	m_bTempNewPlace = true;
	if(readCe3(rce3,&m_listTemp,NULL,&sheetInfo)){
		resetSelect_1(false);
		m_sizeSheet.setW(sheetInfo.width());
		m_sizeSheet.setH(sheetInfo.height());
		m_editLayer = sheetInfo.editLayer();
		m_visibleLayer = sheetInfo.visbleLayer();
		m_nOldestOpCount = m_nOpCount;
		m_bDirty = false;
		m_bTempDirty = false;
		return 0;
	}else{
		resetSelect_1(true);
		fclose(fp);
		return 1;
	}
}



int SXBSchDoc::readFile(const char* fname)
{
	init();
	FILE* fp;
	if((fp = fopen(fname,"r"))==NULL) return 1;
	int retval = readFile(fp);
	fclose(fp);
	return retval;
}


int SXBSchDoc::writeFile(FILE* fp)
{
	if(fp ==NULL) return 1;
	SWriteCE3 wce3;
	wce3.Attach(fp);
	SXBSchSheetInfo sheetInfo;
	sheetInfo.setWidth( m_sizeSheet.w() );
	sheetInfo.setHeight( m_sizeSheet.h() );
	sheetInfo.setEditLayer(m_editLayer);
	sheetInfo.setVisbleLayer(m_visibleLayer);

	wce3.WriteRecord("+BSCH3_DATA_V.1.0");
	wce3.WriteEOL();
	sheetInfo.writeCe3(wce3,NULL);
	writeCe3(wce3,&m_listMain,false,NULL);
	wce3.WriteRecord("-BSCH3_DATA_V.1.0");
	if(wce3.WriteEOL()==EOF){
		return 1;
	}else{		
		return 0;
	}
}

//եؤν񤭹
//ｪλ0֤
int SXBSchDoc::writeFile(const char* fname)
{
	resetSelect();
	FILE* fp;
	if((fp = fopen(fname,"w"))==NULL) return 1;
	int retval = writeFile(fp);
	fclose(fp);
	if(retval==0){
		init();
		readFile(fname);
	}
	return retval;
}


//
//ɥȤѹäȤtrue֤
bool SXBSchDoc::del()
{
	// >>> 2005/01/30 
	//     ƥե饰 resetSelect_1()ǹԤ褦ѹ
	//	m_bDirty = true;	
	// <<< 2005/01/30
	return resetSelect_1(true);
}

//ڤ
//ɥȤѹäȤtrue֤
bool SXBSchDoc::cut()
{
	if(copy()){
		return del();
	}
	return false;
}


//Undo
//ɥȤѹäȤtrue֤
bool SXBSchDoc::undo()
{
//printf("SXBSchDoc::undo() %d %d\n",m_nOpCount, m_nOldestOpCount);
//TRACE("SXBSchDoc::undo() %d %d\n",m_nOpCount, m_nOldestOpCount);
	bool bResult = 	resetSelect();
	if(m_nOpCount <= m_nOldestOpCount){
//TRACE("exit undo 1\n");
		return bResult;
	}

	int nCount = m_listMain.size();
	if(nCount==0){
//TRACE("exit undo 2\n");
		return bResult;
	}

	XBSchObjListIterator pObjIte =m_listMain.begin();
	while(pObjIte!=m_listMain.end()){
		if((*pObjIte)->placeNum() == m_nOpCount){ //UndoоݤΥ֥Ȥʤ...
			if((*pObjIte)->id() == SXBSchObj::ID_DELETEOBJ){		//   ⤷줬֥Ȥʤ
				(*pObjIte)->refObj()->setRefObj(NULL);				//		֥ȤλȤƤ륪֥ȤΤ
				delete (*pObjIte);									//UndoоݤΥ֥Ȥõ
				pObjIte = m_listMain.erase(pObjIte);				//erase()ǥȥΡɤϰĿʤ
			}else{													
				pObjIte++;
			}
		}else{
			pObjIte++;
		}
	}

	pObjIte =m_listMain.begin();
	while(pObjIte!=m_listMain.end()){
		if((*pObjIte)->placeNum() == m_nOpCount){ //UndoоݤΥ֥Ȥʤ...
			delete (*pObjIte);										//UndoоݤΥ֥Ȥõ
			pObjIte = m_listMain.erase(pObjIte);					//erase()ǥȥΡɤϰĿʤ
		}else{
			pObjIte++;
		}
	}



//	XBSchObjListIterator pObjIte =m_listMain.begin();
//	while(nCount && pObjIte!=m_listMain.end()){
//		if((*pObjIte)->placeNum() == m_nOpCount){ //UndoоݤΥ֥Ȥʤ...
//			if((*pObjIte)->id() == SXBSchObj::ID_DELETEOBJ){		//   ⤷줬֥Ȥʤ
//				(*pObjIte)->refObj()->setRefObj(NULL);				//		֥ȤλȤƤ륪֥ȤΤ
//			}														//   ʤΤǡ褵
//			delete (*pObjIte);										//UndoоݤΥ֥Ȥõ
//			pObjIte = m_listMain.erase(pObjIte);					//erase()ǥȥΡɤϰĿʤ
//		}else{
//			pObjIte++;
//		}
//		nCount--;
//	}

	m_nOpCount--;
//TRACE("exit undo 3\n");
	return true;
}

//Attributeѹǽ?
bool SXBSchDoc::canAttribute()
{
	int n=m_listTemp.size();
	if(n!=1) return false;
	XBSchObjListIterator pObjIte =m_listTemp.begin();
	return (*pObjIte)->canAttribute();
}

//ԡǽ
bool SXBSchDoc::canCopy()
{
	return (m_listTemp.size()>0);
}

//ǽ
bool SXBSchDoc::canDel()
{
	return (m_listTemp.size()>0);
}

//ڤǽ
bool SXBSchDoc::canCut()
{
	return (m_listTemp.size()>0);
}


//Undoǽ
bool SXBSchDoc::canUndo()
{
	return (m_nOpCount > m_nOldestOpCount);
}



//Rotate
bool SXBSchDoc::rotate()
{
	if(!canRotate()) return false;

	setupRotateRect();

	int n = m_listTemp.size();
	XBSchObjListIterator pObjIte = m_listTemp.begin();
	if(n == 1){
		(*pObjIte)->rotate();
	}else{
		SPoint ptCenter = m_rcRotateRect.center();
		ptCenter.setX(((ptCenter.x()+5)/10)*10);
		ptCenter.setY(((ptCenter.y()+5)/10)*10);
		//int x=(m_rcRotateRect.l()+m_rcRotateRect.r())/2;
		//int y=(m_rcRotateRect.t()+m_rcRotateRect.bottom())/2;
		//SPoint ptCenter(x,y);
		while(pObjIte != m_listTemp.end()){
			(*pObjIte)->rotate(ptCenter);
			pObjIte++;
		}
	}
	setupRcTempArea();

	// >>> 2005/01/30 
	//	ΤǡΥƥѹ
	//m_bDirty = true;
	m_bTempDirty = true;
	// <<< 2005/01/30 
	
	return true;
}

//쥤䡼ΰư
bool SXBSchDoc::moveToLayer(int nLayer)
{
	XBSchObjListIterator pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		(*pObjIte)->setLayer(nLayer);
		pObjIte++;
	}
	// >>> 2005/01/30 
	//	ΤǡΥƥѹ
	//m_bDirty = true;
	m_bTempDirty = true;
	// <<< 2005/01/30 
	return true;
}


//Mirror
bool SXBSchDoc::mirror()
{
	if(!canMirror()) return false;

	setupRotateRect();

	int n = m_listTemp.size();
	XBSchObjListIterator pObjIte = m_listTemp.begin();
	if(n == 1){
		(*pObjIte)->mirrorH();
	}else{
		int nCenter = (m_rcRotateRect.l()+m_rcRotateRect.r())/2;
		while(pObjIte != m_listTemp.end()){
			(*pObjIte)->mirrorH(nCenter);
			pObjIte++;
		}
	}
	setupRcTempArea();

	// >>> 2005/01/30 
	//	ΤǡΥƥѹ
	//m_bDirty = true;
	m_bTempDirty = true;
	// <<< 2005/01/30 
	return true;
}


//Rotateǽ
bool SXBSchDoc::canRotate()
{
	if(m_listTemp.size() == 0) return false;
	if(m_bSelectForDrag) return false;
	return true;
}

//Mirrorǽ
bool SXBSchDoc::canMirror()
{
	if(m_listTemp.size() == 0) return false;
	if(m_bSelectForDrag) return false;
	return true;
}



//Ť̵ǡκ
//   ᥤΥꥹȤƬ饹󤷤ơꤷͤ
// 꾮ͤǤκԤä֥Ȥõ롣
//   ֥ȤȤб֥ȤΥꥹȤǤ
// ֤ܤȡʤ餺֥ȤƬ˶ᤤ
// ¸ߤ롣
void SXBSchDoc::delOldData(int nOpCount)
{
	bool bDel;
	resetSelect();
	if(nOpCount <= m_nOldestOpCount) return;
	
	int nDelObj=0;
	int nDelDelObj=0;


	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte!=m_listMain.end()){
		bDel = false;
		if((*pObjIte)->id() != SXBSchObj::ID_DELETEOBJ){
			if((*pObjIte)->refObj()!=NULL){
				SXBSchObj* pDelObj = (*pObjIte)->refObj();
				if(pDelObj->placeNum() < nOpCount){
					bDel = true;
					nDelObj++;
				}
			}
		}else{
			if((*pObjIte)->placeNum() < nOpCount){
				bDel = true;
				nDelDelObj++;
			}
		}
		if(bDel){
			delete (*pObjIte);						//UndoоݤΥ֥Ȥõ
			pObjIte = m_listMain.erase(pObjIte);	//erase()ǥȥΡɤϰĿʤ
		}else{
			pObjIte++;
		}
	}
	if(nOpCount > m_nOpCount) nOpCount = m_nOpCount;
	m_nOldestOpCount = nOpCount;



	return;
}

//ꤷɸǡξ夫ɤ
int SXBSchDoc::isOnTempData(const SPoint& pt)
{
	if(m_listTemp.size() == 0) return 0;
	if((m_listTemp.size() == 1)&&(m_bSelectForDrag==false)){
		XBSchObjListIterator pObjIte = m_listTemp.begin();
		int val= (*pObjIte)->qSelectWeight(pt) & (ON_OBJ|ON_NAME|ON_NUM);
		if(val)return val;
	}
	if(m_rcTempArea.intersect(pt)) 	return ON_OBJ;
	return 0;
}

//ǡư
void SXBSchDoc::moveTempData(int offsetx,int offsety)
{
	XBSchObjListIterator pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		(*pObjIte)->move(offsetx,offsety);
		pObjIte++;
	}
	m_rcTempArea+=SPoint(offsetx,offsety);
	m_ptTempSnapPoint.setX(m_ptTempSnapPoint.x()+offsetx);
	m_ptTempSnapPoint.setY(m_ptTempSnapPoint.y()+offsety);
	// >>> 2005/01/30 
	//	ΤǡΥƥѹ
	//m_bDirty = true;
	m_bTempDirty = true;
	// <<< 2005/01/30 
}

//ꤷ˥ԥ󡢥󥯥󤬸Ĥä饼Ĺ磻䡼֤
bool SXBSchDoc::selectForDragPin(int scanMax,const SPoint pt)
{
//	if(!m_bDoTidyUp) return false;
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(scanMax>0 && pObjIte != m_listMain.end()){
		if(   (*pObjIte)->layer() == m_editLayer
		   //&& (*pObjIte)->id()!=SXBSchObj::ID_JUNCTION
		   && (*pObjIte)->id()!=SXBSchObj::ID_WIRE
		   && (*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			bool bFind = false;
			if((*pObjIte)->id()==SXBSchObj::ID_JUNCTION){
				if((*pObjIte)->p1()==pt){
					bFind = true;
				}
			}else{
				int pincount=(*pObjIte)->pinCount();
				for(int n=0;n<pincount;n++){
					SPoint pinpt=(*pObjIte)->pinPosition(n);
					if(pinpt == pt){
						bFind = true;
						break;
					}
				}
			}
			if(bFind){
				SXBSchWire* pWire = new SXBSchWire;
				pWire->setP1(pt);
				pWire->setP2(pt);
				pWire->setLayer(m_editLayer);
				pWire->setSelection(SXBSchObj::SELECT_P1);
				m_listWorkWire.push_back(pWire);
				return true;
			}
		}
		pObjIte++;
		scanMax--;
	}
	return false;
}

//ϰܹ
void SXBSchDoc::selectForDragJunction(int scanMax,const SRect& rc)
{
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(scanMax>0 && pObjIte != m_listMain.end()){
		if(   (*pObjIte)->layer() == m_editLayer
		   && (*pObjIte)->id()==SXBSchObj::ID_JUNCTION 
		   && (*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			unsigned nSelStatus = (*pObjIte)->testSelectionForDrag(rc);
			if(nSelStatus){
				SXBSchObj* pNewObj = (*pObjIte)->duplicate();	//򥪥֥Ȥʣ
				(*pObjIte)->setRefObj(pNewObj);					//쥪֥Ȥʣ֥Ȥ
				pNewObj->setRefObj(*pObjIte);					//֥Ȥ˸֥Ȥ
				pNewObj->setSelection(nSelStatus);				//֥Ȥե饰
				m_listTemp.push_back(pNewObj);					//֥Ȥǡݴ
			}
		}
		*pObjIte++;
		scanMax--;
	}
}

//٤Ƥܹ m_listWorkJunc Ф롣
void SXBSchDoc::pickupJunction(const SRect& )
{
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte != m_listMain.end()){
		if(    (*pObjIte)->layer() == m_editLayer  
			&& (*pObjIte)->id()==SXBSchObj::ID_JUNCTION 
			&& (*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			m_listWorkJunc.push_back(*pObjIte);					//򳰤ܹȥꥢݴ
		}
		*pObjIte++;
	}
}



//ɥåΤܹ磻䡼ʳ
void SXBSchDoc::selectForDragExceptJuncWire(int scanMax,const SRect& rc)
{
	int scan=0;
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(scan<scanMax && pObjIte != m_listMain.end()){
		if( (*pObjIte)->layer() == m_editLayer
		  &&(*pObjIte)->id()!=SXBSchObj::ID_JUNCTION 
		  &&(*pObjIte)->id()!=SXBSchObj::ID_WIRE
		  &&(*pObjIte)->refObj()==NULL){
			unsigned nSelStatus = (*pObjIte)->testSelectionForDrag(rc);
			if(nSelStatus){
				SXBSchObj* pNewObj = (*pObjIte)->duplicate();	//򥪥֥Ȥʣ
				(*pObjIte)->setRefObj(pNewObj);					//쥪֥Ȥʣ֥Ȥ
				pNewObj->setRefObj(*pObjIte);					//֥Ȥ˸֥Ȥ
				pNewObj->setSelection(nSelStatus);				//֥Ȥե饰
				m_listTemp.push_back(pNewObj);					//֥Ȥǡݴ
			}
		}
		*pObjIte++;
		scan++;
	}
}

//ɥåΤΥԥ
void SXBSchDoc::selectForDragPinConnection(int scanMax,const SRect& rrc,bool bCutOffPinWire)
{
	SRect rc;
	rc.setL(rrc.l()+14);
	rc.setT(rrc.t()+14);
	rc.setR(rrc.r()-14);
	rc.setB(rrc.b()-14);

	//ϰϳʤ³ƤǽΤݥȤ󤹤롣
	SPointEmum pointEnum;
	SPoint point;
	
	XBSchObjListIterator pObjIte;

	if(!bCutOffPinWire){
		pObjIte = m_listWorkWire.begin();
		while(pObjIte != m_listWorkWire.end()){
			unsigned selflag = (*pObjIte)->selection();
			if(selflag & SXBSchObj::SELECT_P1){
				point = (*pObjIte)->p1();
				if(!rc.intersect(point)){
					pointEnum.addSPoint(point);
				}
			}
			if(selflag & SXBSchObj::SELECT_P2){
				point = (*pObjIte)->p2();
				if(!rc.intersect(point)){
					pointEnum.addSPoint(point);
				}
			}
			pObjIte++;
		}
	}

	int tempSize = m_listTemp.size();
	pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		if( (*pObjIte)->id()==SXBSchObj::ID_COMPONENT 
			||(*pObjIte)->id()==SXBSchObj::ID_TAG
			){
			int pincount=(*pObjIte)->pinCount();
			for(int n=0;n<pincount;n++){
				point=(*pObjIte)->pinPosition(n);
				if(!rc.intersect(point)){
					pointEnum.addSPoint(point);
				}
			}
		}
		pObjIte++;
	}


	SPointListIterator itePoint=pointEnum.m_list.begin();
	while(itePoint!=pointEnum.m_list.end()){
		point = (*itePoint); 
		if(m_bDoTidyUp){
			if(!selectForDragPin(scanMax,point)){
				SRect rcPin(point,point);
				selectForDragWire(scanMax,rcPin);
			}
		}else{
			SRect rcPin(point,point);
			selectForDragJunction(scanMax,rcPin);
			selectForDragWire(scanMax,rcPin);
		}
		itePoint++;
	}

//	int tempSize = m_listTemp.size();
//	XBSchObjListIterator pObjIte = m_listTemp.begin();
//	int scan = 0;
//	while(scan<tempSize && pObjIte != m_listTemp.end()){
//		if( (*pObjIte)->id()!=SXBSchObj::ID_JUNCTION 
//			&&(*pObjIte)->id()!=SXBSchObj::ID_WIRE){
//
//			int pincount=(*pObjIte)->pinCount();
//			//qDebug("SXBSchDoc::selectForDragExceptJuncWire()  PINCOUNT=%d",pincount);
//			for(int n=0;n<pincount;n++){
//				SPoint pt=(*pObjIte)->pinPosition(n);
//				if(!rc.intersect(pt)){
//					if(m_bDoTidyUp){
//						if(!selectForDragPin(scanMax,pt)){
//							SRect rcPin(pt,pt);
//							//selectForDragJunction(scanMax,rcPin);
//							selectForDragWire(scanMax,rcPin);
//						}
//					}else{
//						SRect rcPin(pt,pt);
//						selectForDragJunction(scanMax,rcPin);
//						selectForDragWire(scanMax,rcPin);
//					}
//				}
//			}
//		}
//		pObjIte++;
//		scan++;
//	}
}


//ɥåΤΥ磻䡼
void SXBSchDoc::selectForDragWire(int scanMax,const SRect& rc)
{
	SXBSchWire* pNewWire[5];

	int workWireCount= m_listWorkWire.size();	//m_listWorkWire뤬Ʊ rcɲäΤϺƥ󤷤ʤ
												//selectForDragǺǽϰϻǤΥ磻䡼ǤworkWireCount0ˤʤ롣

	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(scanMax>0 && pObjIte != m_listMain.end()){
		if( (*pObjIte)->layer() == m_editLayer
		  &&(*pObjIte)->id()==SXBSchObj::ID_WIRE 
		  &&(*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			SXBSchWire* pObj= (SXBSchWire*)(*pObjIte);
			int divcount = divideWire(pObj,rc,pNewWire);
			if(divcount>0){
				SXBSchDelObj* pDelObj = new SXBSchDelObj;		//쥪֥Ȥõ뤿ξõ֥Ȥ
				(*pObjIte)->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
				pDelObj->setRefObj(*pObjIte);					//õ֥Ȥ˵쥪֥Ȥ
				pDelObj->setPlaceNum(m_nOpCount+1);				
				pushBackToMainList(pDelObj,false);
//20060604				m_listMain.push_back(pDelObj);					//õ֥Ȥᥤǡݴ
				for(int n=0;n<divcount;n++){
					m_listWorkWire.push_back(pNewWire[n]);
				}
			}
		}
		pObjIte++;
		scanMax--;
	}

	pObjIte = m_listWorkWire.begin();
	while(workWireCount>0 && pObjIte != m_listWorkWire.end()){
		if((*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			SXBSchWire* pObj= (SXBSchWire*)(*pObjIte);
			int divcount = divideWire(pObj,rc,pNewWire);
			if(divcount>0){
				(*pObjIte)->setRefObj(pNewWire[0]);
				for(int n=0;n<divcount;n++){
					m_listWorkWire.push_back(pNewWire[n]);
				}
			}
		}
		pObjIte++;
		workWireCount--;
	}

}


//ɥåǤϥ磻䡼ʣduplicate()ǤϤʤdivideWire()ǹԤ
// ʣ줿֥Ȥˤե饰ꤵ롣
//磻䡼ɥåоݤǤʤʣʤ
//ɥåоݤɥåоݤʬ䤹ϥɥåоݤΤΤƬ˳Ǽ롣
int SXBSchDoc::divideWire(SXBSchWire* swire,const SRect& rc,SXBSchWire** dwire)
{
	int retval=0;
	bool vFlag;
	int fixval,jfix,jp;
	int p0,p1,p2,p3,p4,p5;
	int	boundaryMin,boundaryMax;
	unsigned int nSelStatus;
	unsigned int nOldSelStatus;
	int nLayer = swire->layer();

	if(!swire->qValid()) return 0;

	nOldSelStatus = (swire->selection() & (SXBSchObj::SELECT_P1|SXBSchObj::SELECT_P2));
	nSelStatus = swire->testSelectionForDrag(rc);

	//򤷤Τƥ󤹤뤹Υå
	if(nOldSelStatus){
		swire->setSelection(nOldSelStatus | nSelStatus);
		return 0;
	}

	nSelStatus = swire->testSelectionForDrag(rc);
	if((nSelStatus&(SXBSchObj::SELECT_P1|SXBSchObj::SELECT_P2)) ==SXBSchObj::SELECT_ALL){	//ξüϰΤȤ
		dwire[0] = (SXBSchWire*)(swire->duplicate());
		dwire[0]->setSelection(nSelStatus);
		return 1;
	}
	if(swire->x1()==swire->x2()){	//ľΤȤ
		if(swire->x1()<rc.l() || swire->x1()>rc.r()) return 0;	//ϰϳ
		if(swire->y1()<rc.t() && swire->y2()<rc.t()) return 0;	//ϰϳ
		if(swire->y1()>rc.b() && swire->y2()>rc.b()) return 0;	//ϰϳ
		vFlag = true;
		fixval = swire->x1();
		p0 = swire->y1();
		p5 = swire->y2();
		boundaryMin = rc.t();
		boundaryMax = rc.b();
	}else if(swire->y1()==swire->y2()){	//ʿΤȤ
		if(swire->y1()<rc.t() || swire->y1()>rc.b()) return 0;	//岼ϰϳ
		if(swire->x1()<rc.l() && swire->x2()<rc.l()) return 0;	//ϰϳ
		if(swire->x1()>rc.r() && swire->x2()>rc.r()) return 0;	//ϰϳ
		vFlag = false;
		fixval = swire->y1();
		p0 = swire->x1();
		p5 = swire->x2();
		boundaryMin = rc.l();
		boundaryMax = rc.r();
	}else{	//ФΤȤʬ䤷ʤ
		if(nSelStatus!=0){
			dwire[0]=(SXBSchWire*)(swire->duplicate());
			dwire[0]->setSelection(nSelStatus);
			return 1;
		}else{
			return 0;
		}
	}
	if(p0>p5){ int i=p5; p5=p0; p0=i; }

	p3=p1=p0;
	p2=p4=p5;

	if(p0>=boundaryMin) p2=p0;
	if(p5<=boundaryMax) p3=p5;
	XBSchObjListIterator pObjIte = m_listWorkJunc.begin();
	while(pObjIte != m_listWorkJunc.end()){
		SXBSchJunc* pJunc = (SXBSchJunc*)(*pObjIte);
		if(vFlag){  jfix = pJunc->x1();	jp	 = pJunc->y1();	}
		else{		jfix = pJunc->y1();	jp	 = pJunc->x1();	}
		if(jfix==fixval && jp>p1 && jp<p4){
			if(jp<boundaryMin){			//p1å(boundaryMin꾮ƺ)
				p1=jp;
			}else if(jp>boundaryMax){	//p4å(boundaryMax礭ƺǾ)
				p4=jp;
			}else{	//ܹϰ
				if(jp>p3) p3=jp;
				if(jp<p2) p2=jp;
			}
		}
		pObjIte++;
	}
	if(p2>p3){//ϰüܹʤʬ䤷ʤ
		return 0;
	}
	if(p2<p3){//ϰξüĥ磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p2));
			dwire[retval]->setP2(SPoint(fixval,p3));
		}else{
			dwire[retval]->setP1(SPoint(p2,fixval));
			dwire[retval]->setP2(SPoint(p3,fixval));
		}
		dwire[retval]->setSelection(SXBSchObj::SELECT_ALL);
		dwire[retval]->setLayer(nLayer);
		retval++;
	}
	if(p1<p2){//ϰP2üĥ磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p1));
			dwire[retval]->setP2(SPoint(fixval,p2));
		}else{
			dwire[retval]->setP1(SPoint(p1,fixval));
			dwire[retval]->setP2(SPoint(p2,fixval));
		}
		dwire[retval]->setSelection(SXBSchObj::SELECT_P2);
		dwire[retval]->setLayer(nLayer);
		retval++;
	}
	if(p3<p4){//ϰP1üĥ磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p3));
			dwire[retval]->setP2(SPoint(fixval,p4));
		}else{
			dwire[retval]->setP1(SPoint(p3,fixval));
			dwire[retval]->setP2(SPoint(p4,fixval));
		}
		dwire[retval]->setSelection(SXBSchObj::SELECT_P1);
		dwire[retval]->setLayer(nLayer);
		retval++;
	}
	if(p0<p1){//ϰϳ˥磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p0));
			dwire[retval]->setP2(SPoint(fixval,p1));
		}else{
			dwire[retval]->setP1(SPoint(p0,fixval));
			dwire[retval]->setP2(SPoint(p1,fixval));
		}
		dwire[retval]->setLayer(nLayer);
		retval++;
	}
	if(p4<p5){//ϰϳ˥磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p4));
			dwire[retval]->setP2(SPoint(fixval,p5));
		}else{
			dwire[retval]->setP1(SPoint(p4,fixval));
			dwire[retval]->setP2(SPoint(p5,fixval));
		}
		dwire[retval]->setLayer(nLayer);
		retval++;
	}
	return retval;
}


int SXBSchDoc::selectForDrag(const SRect& rc,bool bCutOffPinWire)
{
	//ǡβ
	resetSelect();
	m_listWorkJunc.clear();
	m_listWorkWire.clear();

	int scanMax = m_listMain.size();

	//ܹ
	pickupJunction(rc);
	selectForDragJunction(scanMax,rc);

	//磻䡼
	//ϰ⳰ˤޤΤϥ󥯥ˤʬԤ
	selectForDragWire(scanMax,rc);

	//ܹ磻䡼ʳ
	selectForDragExceptJuncWire(scanMax,rc);

	selectForDragPinConnection(scanMax,rc,bCutOffPinWire);


	XBSchObjListIterator pObjIte = m_listWorkWire.begin();
	while(pObjIte != m_listWorkWire.end()){
		if((*pObjIte)->refObj()==NULL){	//ȥ֥ȤʤΤͭ
			if((*pObjIte)->selection()!=0){	//ե饰դƤΤϰǡ˥ԡ
				m_listTemp.push_back(*pObjIte);
			}else{
				(*pObjIte)->setPlaceNum(m_nOpCount+1);
				pushBackToMainList(*pObjIte,false);
//20060603				m_listMain.push_back(*pObjIte);
			}
		}else{
			delete(*pObjIte);
		}
		pObjIte++;
	}

	
	setupRcTempArea();
	setupRotateRect();
	m_listWorkJunc.clear();
	m_listWorkWire.clear();

	int nSelectCount = m_listTemp.size();
	if(nSelectCount >0){
		m_bSelectForDrag = true;
		m_bTempDirty = true;
		m_bFindCommandActive = false;
	}else{
		m_bSelectForDrag = false;
	}
	return nSelectCount;
//	m_bSelectForDrag = true;
//	return m_listTemp.size();
}

bool SXBSchDoc::findStringCompare(const char* szTarget,const char* sz,bool bMatchWhole)
{
	if(szTarget==NULL || sz==NULL)return false;
	if(*szTarget=='\0' || *sz=='\0') return false;

	if(bMatchWhole){
		return !(strcmp(szTarget,sz));
	}else{
		return (strstr(szTarget,sz)!=NULL);
	}
}

bool SXBSchDoc::findStart(const char* sz,bool bMatchWhole,unsigned int targetFlags)
{
	resetSelect();
	m_strFind = sz;
	m_bFindMatchWhole = bMatchWhole;
	m_nTargetFlags = targetFlags;
	return find(true);
}

bool SXBSchDoc::find(bool bStart /*=false*/)
{
	SXBSchObj* pObj = NULL;
	SXBSchObj* pObjSelected = NULL;
	resetSelect();

	if(bStart){
	    m_reviteFind = m_listMain.rbegin();
		m_bFindCommandActive = true;
	}else{
		if(!m_bFindCommandActive)return false;
		m_reviteFind++;
	}

	while(m_reviteFind != m_listMain.rend()){
		if( (*m_reviteFind)->layer() == m_editLayer
		  &&(*m_reviteFind)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			pObj = *m_reviteFind;
			int nId = pObj->id();
			switch(nId){
				case SXBSchObj::ID_COMPONENT:
					if(m_nTargetFlags & FINDTGT_NAME){
						if(findStringCompare(((SXBSchComponent*)pObj)->name(),m_strFind.c_str(),m_bFindMatchWhole)){
							pObjSelected = pObj;
							break;
						}
					}
					if(m_nTargetFlags & FINDTGT_NAMELIB){
						if(findStringCompare(((SXBSchComponent*)pObj)->orgname(),m_strFind.c_str(),m_bFindMatchWhole)){
							pObjSelected = pObj;
							break;
						}
					}
					if(m_nTargetFlags & FINDTGT_NUM){
						if(findStringCompare(((SXBSchComponent*)pObj)->refnum(),m_strFind.c_str(),m_bFindMatchWhole)){
							pObjSelected = pObj;
							break;
						}
					}
					break;
				case SXBSchObj::ID_TAG:
					if(m_nTargetFlags & FINDTGT_TAG){
						if(findStringCompare(((SXBSchTag*)pObj)->text(),m_strFind.c_str(),m_bFindMatchWhole)){
							pObjSelected = pObj;
							break;
						}
					}
					break;
				case SXBSchObj::ID_LABEL:
					if(m_nTargetFlags & FINDTGT_LABEL){
						if(findStringCompare(((SXBSchLabel*)pObj)->text(),m_strFind.c_str(),m_bFindMatchWhole)){
							pObjSelected = pObj;
							break;
						}
					}
					break;
				case SXBSchObj::ID_COMMENT:
					if(m_nTargetFlags & FINDTGT_COMMENT){
						if(findStringCompare(((SXBSchComment*)pObj)->text(),m_strFind.c_str(),m_bFindMatchWhole)){
							pObjSelected = pObj;
							break;
						}
					}
					break;
				default:
					break;
			}
		}
		if(pObjSelected != NULL) break;
		m_reviteFind++;
	}
	if(pObjSelected != NULL){
		SXBSchObj* pNewObj = pObjSelected->duplicate();
		pObjSelected->setRefObj(pNewObj);
		pNewObj->setRefObj(pObjSelected);
		pNewObj->setSelection(SXBSchObj::SELECT_ALL);
		m_listTemp.push_back(pNewObj);
	}else{
		m_bFindCommandActive = false;
	}
	setupRcTempArea();
	setupRotateRect();
	m_bSelectForDrag = false;
	return (pObjSelected!=NULL);
}



