#/bin/sh

case "$1" in

	clean)
		rm -rf qbsv047
		echo; echo "# cleaned"
		;;

	*)
		if [ ! -e qbsv047.tgz ]
		then
				echo; echo "# get sources"
				wget http://www.suigyodo.com/online/e/qbsv047.tgz
		fi

		echo; echo "# check sources"
		if [ "`md5sum qbsv047.tgz`" != '6d1b33dd04cb54103992dfe1b9cdeab2  qbsv047.tgz' ]
		then
				echo; echo "# FATAL. sources is not match..."
				exit
		fi

		echo; echo "# extract sources"
		tar xvfz qbsv047.tgz
		cd qbsv047/qtbsch3v/

		echo; echo "# convert sources to utf8"
		find . -name "*.cpp" | sed "s/^/..\/..\/cnv_utf8.rb /" | sh
		find . -name "*.h"   | sed "s/^/..\/..\/cnv_utf8.rb /" | sh
		find . -name "*.cfg" | sed "s/^/..\/..\/cnv_utf8.rb /" | sh

		# http://www.itline.jp/~svx/diary/?date=20090204
		echo; echo "# patching to Ver.1.01"
		patch < ../../qbsv047-1.01.patch

		# http://www.itline.jp/~svx/diary/?date=20090210
		echo; echo "# patching to Ver.1.10"
		patch < ../../qbsv047-1.10.patch

		# http://www.itline.jp/~svx/diary/?date=20130719
		echo; echo "# patching to Ver.1.20"
		patch < ../../qbsv047-1.20.patch

		echo; echo "# copy & paste following commands to build"
		echo "cd qbsv047/qtbsch3v/; qmake-qt4"
		echo "mv Makefile Makefile.org; cat Makefile.org | sed \"s/-O2/-O2 -fpermissive/\" > Makefile"
		echo "make"
esac

